
#ifndef _GenP_h
#define _GenP_h

#include <X11/CoreP.h>
#include "Gen.h"

typedef struct
  {
  int dummy;		/* Make non-GNU compilers happy */
  } GenClassPart;

typedef struct
  {
  CoreClassPart core_class;
  GenClassPart gen_class;
  } GenClassRec;

typedef struct _GenPart
  {
  /* Resources */

  XtPointer *data;	/* Data attached to this widget, to display */

  /* This is used to attach arbitrary data to a Gen Widget, to make it */
  /* into a generalized kind of widget */

  XtCallbackList redraw;	/* Called to redraw the picture, after the */
  /* default redraw procedure has consolidated the region to */
  /* be drawn. */

  XtCallbackList destroy;	/* Called to destroy user-created parts of */
  /* the widget */
  } GenPart;

typedef struct _GenRec
  {
  CorePart core;
  GenPart gen;
  } GenRec;

#endif /* _GenP_h */
