
/* --- feature switches --- */

#define _POSIX_SOURCE 1

/* --- system headers --- */

#include <stdio.h>
#include <math.h>

/* --- local headers --- */


/* --- function prototypes */

int Inpoly(float x, float y, int num, float **poly);

/* --- functions --- */

int line_in_rect(float x1, float y1, float x2, float y2, float **poly1,
		 float newx[2], float newy[2])
  {
  int m, n;
  float dx, dy, slope1, b, ex, why; 

  if((x1 > poly1[0][0]) && (x1 < poly1[1][0]) && (x2 > poly1[0][0])
     && (x2 < poly1[1][0]) && (y1 > poly1[0][1]) && (y1 < poly1[2][1])
     && (y2 > poly1[0][1]) && (y2 < poly1[2][1]))
    {
    /* fprintf(stderr,"both points inside\n"); */
    return(-1);
    }

  m = 0;
  dx = x2 - x1;
  dy = y2 - y1;
  if(dx != 0.0) slope1 = dy / dx;
  n = -1;

  if(dx == 0)
    {  
    if(x1 < poly1[0][0] || x1 > poly1[1][0]) return(0);
    if((poly1[2][1] > y1 && poly1[2][1] < y2)
       || (poly1[2][1] < y1 && poly1[2][1] > y2))
      {
      n++;
      newx[n] = x1;
      newy[n] = poly1[2][1];
      }
    if((poly1[1][1] > y1 && poly1[1][1] < y2)
       || (poly1[1][1] < y1 && poly1[1][1] > y2))
      {
      n++;
      newx[n] = x1;
      newy[n] = poly1[1][1];
      }
    return(n + 1);
    }

  if(dy == 0)
    {  
    if(y1 < poly1[0][1] || y1 > poly1[2][1]) return(0);
    
    if((poly1[0][0] > x1 && poly1[0][0] < x2)
       || (poly1[0][0] < x1 && poly1[0][0] > x2))
      {
      n++;
      newx[n] = poly1[0][0];
      newy[n] = y1;
      }

    if((poly1[1][0] > x1 && poly1[1][0] < x2)
       || (poly1[1][0] < x1 && poly1[1][0] > x2))
      {
      n++;
      newx[n] = poly1[1][0];
      newy[n] = y1;
      }
    return(n + 1);
    }

  slope1 = dy / dx;
  b = y1 - slope1 * x1;

  /* fprintf(stderr,"slope=%f  b=%f\n",slope1, b); */
  /*  a = mx + b  */

  /* left side  */
  why = slope1 * poly1[0][0] + b;
  /* fprintf(stderr,"left side %f %f\n",poly1[0][0],why); */
  if(((why < y1 && why > y2) || (why > y1 && why < y2))
     && ((why < poly1[2][1] && why > poly1[1][1])))
    {
    n++;
    newx[n] = poly1[0][0];
    newy[n] = why;
    }

  /* Right side  */
  why = slope1 * poly1[1][0] + b;
  /* fprintf(stderr,"Right side %f %f\n",poly1[1][0],why); */

  if(((why < y1 && why > y2) || (why > y1 && why < y2))
     && ((why < poly1[2][1] && why > poly1[1][1])))
    {
    n++;
    newx[n] = poly1[1][0];
    newy[n] = why;
    }

  /* Bottom side  */
  ex = (poly1[0][1] - b) / slope1;
  /* fprintf(stderr,"Bottom side %f %f\n",ex, poly1[0][1]); */

  if(((ex < x1 && ex > x2) || (ex > x1 && ex < x2))
     && (ex < poly1[1][0] && ex > poly1[0][0]))
    {
    n++;
    newx[n] = ex;
    newy[n] = poly1[0][1];
    }

  /* Top side  */
  ex = (poly1[2][1] - b) / slope1;
  /* fprintf(stderr,"Top side %f %f\n",ex, poly1[2][1]); */

  if(((ex < x1 && ex > x2) || (ex > x1 && ex < x2))
     && (ex < poly1[1][0] && ex > poly1[0][0]))
    {
    n++;
    newx[n] = ex;
    newy[n] = poly1[2][1];
    }
  return(n + 1);
  }
