/* string functions for making some fortran i/o type scans  */
/*
 * provide the function with gstr( string ,  begin , num , return-value)
 * where string is a string array begin is the first place in the string to
 * begin the scan remember that the array starts at 0, not 1. num is the
 * number of places to read in. return-value is either  int, long, or float.
 * gstrf2   attempts to format a float according to the number of decimals in
 * the desired output
 */

/* J. M. Lees 10-18-93  
    modifications:

   Tue Aug  2 13:49:46 EDT 1994

*/


/* --- feature switches --- */

#define _POSIX_SOURCE 1

/* --- system headers --- */

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

/* --- local headers --- */

#include "geotouch.h"

/* --- macros --- */

#define SEPCHARS " \n"

/* --- functions --- */

int Num_Lines(char *source_file)
  {  
  FILE *inf;
  int c, m;

  if((inf = fopen(source_file, "r")) == NULL)
    {
    fprintf(stderr, "Can't open file %s ....try again\n", source_file);
    return(0);
    }

  m = 0; 
  while((c = fgetc(inf)) != EOF) if(c == '\n') m++; 
  return(m);
  }

/* return the current date and time in a string with "_" as separators
   in the string  
   this is useful for writing to a file and then reading in later
   as a simple string   , jtim should be defined in main as:
   char jtim[25];
   */

void get_tim_str(char *jtim)
  {
  int i;
  time_t tim = time(NULL);

  strcpy(jtim, ctime(&tim));
  for(i = 0; i < strlen(jtim); i++) if(jtim[i] == ' ') jtim[i] = '_';
  }

void remove_blanks(char *ident)
  {
  int i;

  for(i = 0; i < strlen(ident); i++)
    if(ident[i] == ' ')	ident[i] = '0';
  }

void blank2under(char *ident)
  {
  int i;

  for(i = 0; i < strlen(ident); i++)
    if(ident[i] == ' ')	ident[i] = '_';
  }

void under2blank(char *ident)
  {
  int i;

  for(i = 0; i < strlen(ident); i++)
    if(ident[i] == '_')	ident[i] = ' ';
  }

/*---------------------------------------------*/

void gstri(char *string1, int begin, int num, int *i)
  {
  char ch[10];

  strncpy(ch, string1 + begin, num);
  ch[num] = '\0';
  *i = atoi(ch);
  }

/*---------------------------------------------*/

void gstrf(char *string1, int begin, int num, float *i)
  {
  char ch[10];

  strncpy(ch, string1 + begin, num);
  ch[num] = '\0';
  *i = atof(ch);
  }

/*---------------------------------------------*/

void gstrf2(char *string1, int begin, int num, float *i, int dec)
  {
  char ch[10];

  strncpy(ch, string1 + begin, num);
  ch[num] = '\0';
  *i = atof(ch) / pow(10, dec);
  }

/*---------------------------------------------*/

void gstrl(char *string1, int begin, int num, long *i)
  {
  char ch[10];

  strncpy(ch, string1 + begin, num);
  ch[num] = '\0';
  *i = atol(ch);
  }

/*---------------------------------------------*/

void gstrc(char *string1, int begin, int num, char *i)
  {

  strncpy(i, string1 + begin, num);
  i[num] = '\0';
  }

/*---------------------------------------------*/

/* flag = 0 retrun count flag = 1 return
 * first occurance flag = 2 retrun last
 * occurance
 */
/*---------------------------------------------*/
int  count_dot(char *s, int flag)
{				/* flag = 0 retrun count flag = 1 return
				 * first occurance flag = 2 retrun last
				 * occurance  */
	int             i, len, n = 0;
	int             pos_first=0, pos_last=0;
	int            *pey;
	len = strlen(s);
	pey = (int *) malloc(len * sizeof(int));

	for (i = 0; i < strlen(s); i++)
		if (s[i] == '.') {
			pey[n] = i;
			n++;
		}
	  
if(n>0){ 
pos_first = pey[0];
pos_last= pey[n-1];

/* printf("num=%d first=%d last=%d \n",n, pey[0], pey[n-1]);*/
}
  

  free(pey);

         switch(flag){
        case 0: return n;
	case 1:	
             if(n >0) return pos_first;
              else return 0;
              break;
	case 2:
           if(n >0) return pos_last;
              else return 0;
              break;
        default:
            return 0;
           break;
    }
          		

   }

int count_backslash(char *s, int flag)
  {
  int i, len, n = 0, pos_first = 0, pos_last = 0, *pey;

  len = strlen(s);
  pey = XmapNewArray(int, len);

  for(i = 0; i < strlen(s); i++)
    if(s[i] == '/') pey[n++] = i;

  if(n > 0)
    { 
    pos_first = pey[0];
    pos_last= pey[n - 1];
    /* printf("num=%d first=%d last=%d \n",n, pey[0], pey[n-1]); */
    }

  XmapFree(pey);

  switch(flag)
    {
    case 0:
      return(n);

    case 1:	
      if(n > 0) return(pos_first);
      else return(0);
      break;

    case 2:
      if(n > 0) return(pos_last);
      else return(0);
      break;

    default:
      return(0);
      break;
    }
  }

/*---------------------------------------------*/

/* line holds the long string */

void break_line(char *line, int *fake_argc, char **fake_argv)
  {
  int i = 0;

  fake_argv[i++] = strtok(line, SEPCHARS); 
  while((fake_argv[i++] = strtok(NULL, SEPCHARS)) != NULL);
  *fake_argc = i - 1;
  } 
